JUCE: ModalComponentManager Class Reference

JUCE

Classes | Public Member Functions | Protected Member Functions | List of all members
ModalComponentManager Class Reference
juce_gui_basics » components

Manages the system's stack of modal components. More...

`#include <juce_ModalComponentManager.h>`

Inheritance diagram for ModalComponentManager:

## Classes
class | Callback
| Receives callbacks when a modal component is dismissed. More...

## Public Member Functions
int | getNumModalComponents () const
| Returns the number of components currently being shown modally. More...
Component * | getModalComponent (int index) const
| Returns one of the components being shown modally. More...
bool | isModal (const Component *component) const
| Returns true if the specified component is in a modal state. More...
bool | isFrontModalComponent (const Component *component) const
| Returns true if the specified component is currently the topmost modal component. More...
void | attachCallback (Component *component, Callback *callback)
| Adds a new callback that will be called when the specified modal component is dismissed. More...
void | bringModalComponentsToFront (bool topOneShouldGrabFocus=true)
| Brings any modal components to the front. More...
bool | cancelAllModalComponents ()
| Calls exitModalState (0) on any components that are currently modal. More...
int | runEventLoopForCurrentComponent ()
| Runs the event loop until the currently topmost modal component is dismissed, and returns the exit code for that component. More...

## Protected Member Functions
| ModalComponentManager ()
| Creates a ModalComponentManager. More...
| ~ModalComponentManager () override
| Destructor. More...
void | handleAsyncUpdate () override

## Detailed Description

Manages the system's stack of modal components.

Normally you'll just use the Component methods to invoke modal states in components, and won't have to deal with this class directly, but this is the singleton object that's used internally to manage the stack.

See also
  Component::enterModalState, Component::exitModalState, Component::isCurrentlyModal, Component::getCurrentlyModalComponent, Component::isCurrentlyBlockedByAnotherModalComponent

## Constructor & Destructor Documentation

## ◆ ModalComponentManager()

ModalComponentManager::ModalComponentManager | ( |  | ) |
| protected

Creates a ModalComponentManager.

You shouldn't ever call the constructor - it's a singleton, so use ModalComponentManager::getInstance()

## ◆ ~ModalComponentManager()

ModalComponentManager::~ModalComponentManager | ( |  | ) |
| overrideprotected

Destructor.

## Member Function Documentation

## ◆ getNumModalComponents()

int ModalComponentManager::getNumModalComponents | ( |  | ) | const

Returns the number of components currently being shown modally.

See also
  getModalComponent

## ◆ getModalComponent()

Component * ModalComponentManager::getModalComponent | ( | int | index | ) | const

Returns one of the components being shown modally.

An index of 0 is the most recently-shown, topmost component.

## ◆ isModal()

bool ModalComponentManager::isModal | ( | const Component * | component | ) | const

Returns true if the specified component is in a modal state.

## ◆ isFrontModalComponent()

bool ModalComponentManager::isFrontModalComponent | ( | const Component * | component | ) | const

Returns true if the specified component is currently the topmost modal component.

## ◆ attachCallback()

void ModalComponentManager::attachCallback | ( | Component * | component,
|  | Callback * | callback
| ) |  |

Adds a new callback that will be called when the specified modal component is dismissed.

If the component is modal, then when it is dismissed, either by being hidden, or by calling Component::exitModalState(), then the Callback::modalStateFinished() method will be called.

Each component can have any number of callbacks associated with it, and this one is added to that list.

The object that is passed in will be deleted by the manager when it's no longer needed. If the given component is not currently modal, the callback object is deleted immediately and no action is taken.

## ◆ bringModalComponentsToFront()

void ModalComponentManager::bringModalComponentsToFront | ( | bool | topOneShouldGrabFocus = `true` | ) |

Brings any modal components to the front.

## ◆ cancelAllModalComponents()

bool ModalComponentManager::cancelAllModalComponents | ( |  | ) |

Calls exitModalState (0) on any components that are currently modal.

Returns
  true if any components were modal; false if nothing needed cancelling

## ◆ runEventLoopForCurrentComponent()

int ModalComponentManager::runEventLoopForCurrentComponent | ( |  | ) |

Runs the event loop until the currently topmost modal component is dismissed, and returns the exit code for that component.

## ◆ handleAsyncUpdate()

void ModalComponentManager::handleAsyncUpdate | ( |  | ) |
| overrideprotectedvirtual

Implements AsyncUpdater.

The documentation for this class was generated from the following file:

- juce_ModalComponentManager.h